﻿import numpy as np
import matplotlib.pyplot as plt
import os
from tkinter import *
from tkinter.filedialog import *
import csv
import statistics
from statistics import mean

# Initialisation des listes numpy contenant z, vz, az, a et t
z=[]    # liste qui contient les valeurs de l'altitude z
vz=[]   # liste qui contient les valeurs de la coordonnée verticale de la vitesse
az=[]   # liste qui contient les valeurs de la coordonnée verticale de l'accélération
a=[]    # liste qui contient les valeurs de l'accélération totale a = az + g
t=[]    # liste qui contient les valeurs de la date t


# Cette partie du code lit le tableau csv généré par phyphox et récupère les valeurs de t et a = az + g
Fenetre = Tk()
Nom_fichier=askopenfilename(title="Ouvrir le fichier généré par phyphox", initialdir=os.getcwd(), initialfile="*.csv;*.txt", filetypes = [("Fichiers Textes tabulés CSV","*.txt;*.csv"),("All", "*.csv;*.txt")])
Fichier_Csv = open(Nom_fichier, 'r')
for ligne in Fichier_Csv:
    if not '(' in ligne :
        t.append(float(ligne.split()[0].replace(',','.')))
        a.append(float(ligne.split()[3].replace(',','.')))
        print ('t='+ligne.split()[0].replace(',','.') + ' - az='+ligne.split()[3].replace(',','.'))

Fichier_Csv.close()
Fenetre.destroy()

Nbre_Mesures=len(t)-1


# Cette partie estime la valeur de g et la soustrait à l'accélération : on obtient la liste az : coordonnée vercticale de l'accélération
g = mean(a)
n=0
while n<=Nbre_Mesures : 
    az.append(a[n]-g)
    n=n+1

# Préparation des fenêtres graphiques
fig=plt.figure()
fig.patch.set_facecolor('#E0E0E0')
fig.patch.set_alpha(0.7)


""" __________________________________________________ 
    Tracé de la coordonnée verticale de l'accélération  """


ax = fig.add_subplot(221)                               # On travaille dans la zone graphique en haut à gauche
ax.patch.set_facecolor('#525354')                       # Couleur du fond

plt.plot(t,az,'-',color='mediumorchid',label='az(t)')   # Trace az en fonction de t sous forme de ligne continue de couleur violette
plt.title("Evolution temporelle de l'accélération")     # Le titre du graphique
plt.xlabel("temps (s)")                                 # La légende de l'axe des abscisses
plt.ylabel("az (m/s²)")                                 # La légende de l'axe des ordonnées

plt.legend()                                            # Ajoute la légende
plt.grid()                                              # Ajoute un quadrillage




""" _____________________________________________________________________ 
    ETAPE ELEVE n° 1 : tracé de la coordonnée verticale de la vitesse  vz
"""
# CALCULS : 
# =========
vz.append(0) # la première valeur de vitesse est nulle
n=1
while n<=Nbre_Mesures : # tant que n est inférieur ou égal au nombre de valeurs enregistrées, exécute ce qui suit 
    # CONSIGNE : saisir ici la formule qui ajoute la valeur vz[n] à la liste vz, à exprimer en fonction de az[n-1], vz[n-1], t[n] et t[n-1]
    n=n+1

# TRACE : 
# =======
ax = fig.add_subplot(223)                               # On travaille dans la zone graphique en bas à gauche
ax.patch.set_facecolor('#525354')                       # Couleur du fond

# CONSIGNE : dans cette ligne, tracer vz en fonction de t sous forme de ligne continue de couleur turquoise
# CONSIGNE : ajouter le titre du graphique
# CONSIGNE : ajouter la légende de l'axe des abscisses
# CONSIGNE : ajouter la légende de l'axe des ordonnées
plt.legend()                                            # Ajoute la légende
plt.grid()                                              # Ajoute un quadrillage

""" _____________________FIN DE L'ETAPE 1________________________________"""


""" _____________________________________________________________________ 
    ETAPE ELEVE n° 2 : tracé de la coordonnée verticale de position  z
"""
# CALCULS : 
# =========
z.append(0)
n=1
while n<=Nbre_Mesures :
    # CONSIGNE : saisir ici la formule qui ajoute la valeur z[n] à la liste vz, à exprimer en fonction de vz[n-1], z[n-1], t[n] et t[n-1]
    n=n+1

# TRACE : 
# =======
ax = fig.add_subplot(122)                       # on travaille maintenant dans la zone graphique de droite
ax.patch.set_facecolor('#525354')               # couleur de la zone

# CONSIGNE : dans cette ligne, tracer vz en fonction de t sous forme de ligne continue de couleur turquoise
# CONSIGNE : ajouter le titre du graphique
# CONSIGNE : ajouter la légende de l'axe des abscisses
# CONSIGNE : ajouter la légende de l'axe des ordonnées

plt.legend()                                    # légender le graphique en fonction de ce qui précède
plt.grid()                                      # ajoute un quadrillage

""" _____________________FIN DE L'ETAPE 2________________________________"""



plt.get_current_fig_manager().window.state('zoomed')   

plt.show()






